#include "DAGH.h"
#include "Consts.h"
#include "ADMvar.h"
#include "SArray.h"
#include "TArray.h"
#include "BHmask.h"
#include "Variables.h"
#include "fortranob.h"
#include "input_params.h"

void  tstep_ob(int iter, int Level, double *params, ADMstensor *g,
      ADMstensor *k, ADMscalar *alpha, ADMvector *beta,
      BHmask *theMask, ADMscalar *obmask, SArray *shift_p,
      SArray *shift_po, TArray *shift_t, ADMtemp *tmp_pool,
      int init, int idt, double Time, int myrank)

{
INTEGER itc;
INTEGER t=0;
DOUBLE endtime;
INTEGER cg;
GridFunction(DIM)<DOUBLE> &st = *(*g).spacetime[0];
int *ntmp = (*(*theMask).nl).data();
int *ni   = (*(*shift_p).n).data();
int *nio  = (*(*shift_po).n).data();
int *npi  = (*(*shift_t).n).data();
int nl;
int num_int_points;
int num_int_pointso;
int np;

// subroutine outerboundaryupdate(t,params, gm1_, g_,  
// gp1_, km1_, k_, kp1_,      alpha, beta_, beta_old_,  
// mask_, mask_old_,obmask)
//   implicit none
//   interface
//     subroutine set_bef_diri(params,x,y,z,r,g_,k_)
//       implicit none
//     end subroutine set_bef_diri
//     subroutine set_harm_diri(params,g_,K_)
//       implicit none
//     end subroutine set_harm_diri
//     subroutine out_boundary(params,x,y,z,r,tempt,sn,snp1)
//       implicit none
//     end subroutine out_boundary
//     subroutine  out_bound(params,k_,x,y,z)
//       implicit none
//     end subroutine out_bound
//     subroutine sommerfeld(params, x, y, z, r, gm1_,  
// g_, gp1_, Km1_, K_, Kp1_)
//       implicit none
//     end subroutine sommerfeld
//     subroutine periodic_obc_symm2(params,gf)
//       implicit none
//     end subroutine periodic_obc_symm2
//     subroutine ib_freeze(params, g_, k_, gp1_, kp1_,  
// mask_, coords_, r)
//      implicit none
//     end subroutine freeze_ib
//     subroutine calc_coords(params,coords_)
//      implicit none
//     end subroutine calc_coords
//     subroutine ob_freeze(g_,gp1_,k_,kp1_)
//     end subroutine ob_freeze
//     subroutine iso(g,k,gold,kold,params)
//     end subroutine iso
//   end interface
#define DIRICHLET 1 

#define SOMMFELD 2 

#define PERIODIC 3 

#define PERTURB_OB 4 

#define CHARACTERISTIC_OB 5 

#define FREEZING 6 

#define PERTURB_SOMM 7 

#define FLATSPACE 0 

#define ISOSCHW 1 

#define LINEARWAVE 3 

#define BOOSTEDEF 4 

#define KERR 5 

#define HARMONIC 6 


if(myrank==0) cout << " start tstep_ob" <<  endl << flush;

double s;
  s = (*(*g).spacetime[0]).GF_sum(t,Level,DAGH_Main);
  if(myrank==0) cout << "g0: " << s << endl << flush;
  s = (*(*g).spacetime[4]).GF_sum(t-idt,Level,DAGH_Main);
  if(myrank==0) cout << "gm14: " << s << endl << flush;
  s = (*(*g).spacetime[3]).GF_sum(t+idt,Level,DAGH_Main);
  if(myrank==0) cout << "gp13: " << s << endl << flush;
  s = (*(*k).spacetime[3]).GF_sum(t,Level,DAGH_Main);
  if(myrank==0) cout << "k3: " << s << endl << flush;



switch ((int)params[P_OUTER_BOUNDARY]) { 
   case DIRICHLET:
 
switch ((int)params[P_ID_TYPE]) { 
   case BOOSTEDEF:
 
  TMPscalar *temp1 = new TMPscalar(tmp_pool);

  TMPscalar *temp2 = new TMPscalar(tmp_pool);

  TMPscalar *temp3 = new TMPscalar(tmp_pool);

  TMPscalar *temp4 = new TMPscalar(tmp_pool);

     forall(st,t,Level,cg){
       f_set_bef_diri(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*temp1).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*temp2).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*temp3).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*temp4).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;


  delete temp1;

  delete temp2;

  delete temp3;

  delete temp4;

  break;

   case HARMONIC:
 
     forall(st,t,Level,cg){
       f_set_harm_diri(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*g).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;

     break;

   default:
if(myrank==0) cout<< "ERROR: Dirichlet condition for initial data   type" << " " 
<<  params[P_ID_TYPE] << " " 
<< " Undefined" << " " 
<< endl;
if(myrank==0) cout<< "      Try Freezing condition" << " " 
<< endl;
} // switch

   break;

   case SOMMFELD:
 
     forall(st,t,Level,cg){
       f_iso(FBA(st(t,Level,cg,DAGH_Main)),
       (*(*g).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t,Level,cg,DAGH_Main).data(),
       params);
     } end_forall;

       break; 

   case PERIODIC:
 
     forall(st,t,Level,cg){
       f_periodic_obc_symm2(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*g).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;


     forall(st,t,Level,cg){
       f_periodic_obc_symm2(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*k).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;

   break;

   case FREEZING:
 
     if(myrank==0) cout << "call ob_freeze" << endl << flush; 


     forall(st,t,Level,cg){
       f_ob_freeze(FBA(st(t,Level,cg,DAGH_Main)),
       (*(*g).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t+idt,Level,cg,DAGH_Main).data());
     } end_forall;

    break;

default:
if(myrank==0) cout<< "Outer Boundary Condition " << " " 
<< params[P_OUTER_BOUNDARY] << " " 
<<           "Unknown " << " " 
<< endl;
} // switch

switch ((int)params[P_INNER_BOUNDARY]) { 
   case 1:
 
  TMPvector *tempv = new TMPvector(tmp_pool);

  TMPscalar *temp5 = new TMPscalar(tmp_pool);

     forall(st,t,Level,cg){
       f_calc_coords(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*tempv).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*tempv).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*tempv).spacetime[2])(t,Level,cg,DAGH_Main).data());
     } end_forall;


     forall(st,t,Level,cg){
       f_ib_freeze(FBA(st(t,Level,cg,DAGH_Main)),
       params,
       (*(*g).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*g).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[0])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[1])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[2])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[3])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[4])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*k).spacetime[5])(t+idt,Level,cg,DAGH_Main).data(),
       (*(*theMask).mask)(t,Level,cg,DAGH_Main).data(),
       (*(*tempv).spacetime[0])(t,Level,cg,DAGH_Main).data(),
       (*(*tempv).spacetime[1])(t,Level,cg,DAGH_Main).data(),
       (*(*tempv).spacetime[2])(t,Level,cg,DAGH_Main).data(),
       (*(*temp5).spacetime[0])(t,Level,cg,DAGH_Main).data());
     } end_forall;


  delete tempv;

  delete temp5;

} // switch

// end subroutine outerboundaryupdate

}
